Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.python.modules
Class struct

    java.lang.Object
      org.python.modules.struct

    public class struct

extends Object

This module performs conversions between Python values and C structs represented as Python strings. It uses format strings (explained below) as compact descriptions of the lay-out of the C structs and the intended conversion to/from Python values.

The module defines the following exception and functions:

`error`
  Exception raised on various occasions; argument is a string describing what is wrong.

`pack` (fmt, v1, v2, ...)
  Return a string containing the values `v1, v2, ...` packed according to the given format. The arguments must match the values required by the format exactly.

`unpack`> (fmt, string)
  Unpack the string (presumably packed by `pack(fmt, ...)`) according to the given format. The result is a tuple even if it contains exactly one item. The string must contain exactly the amount of data required by the format (i.e. `len(string)` must equal `calcsize(fmt)`).

`calcsize` (fmt)
  Return the size of the struct (and hence of the string) corresponding to the given format.

Format characters have the following meaning; the conversion between C and Python values should be obvious given their types:

Format | C Type | Python
--- | --- | ---
`x` | pad byte | no value
`c` | `char` | string of length 1
`b` | `signed char` | integer
`B` | `unsigned char` | integer
`h` | `short` | integer
`H` | `unsigned short` | integer
`i` | `int` | integer
`I` | `unsigned int` | integer
`size` | `long` | integer
`L` | `unsigned long` | integer
`f` | `float` | float
`d` | `double` | float
`s` | `char[]` | string
`p` | `char[]` | string

A format character may be preceded by an integral repeat count; e.g. the format string `'4h'` means exactly the same as `'hhhh'`.

Whitespace characters between formats are ignored; a count and its format must not contain whitespace though.

For the "`s`" format character, the count is interpreted as the size of the string, not a repeat count like for the other format characters; e.g. `'10s'` means a single 10-byte string, while `'10c'` means 10 characters. For packing, the string is truncated or padded with null bytes as appropriate to make it fit. For unpacking, the resulting string always has exactly the specified number of bytes. As a special case, `'0s'` means a single, empty string (while `'0c'` means 0 characters).

The "`p`" format character can be used to encode a Pascal string. The first byte is the length of the stored string, with the bytes of the string following. If count is given, it is used as the total number of bytes used, including the length byte. If the string passed in to `pack()` is too long, the stored representation is truncated. If the string is too short, padding is used to ensure that exactly enough bytes are used to satisfy the count.

For the "`I`" and "`L`" format characters, the return value is a Python long integer.

By default, C numbers are represented in the machine's native format and byte order, and properly aligned by skipping pad bytes if necessary (according to the rules used by the C compiler).

Alternatively, the first character of the format string can be used to indicate the byte order, size and alignment of the packed data, according to the following table:

Character | Byte order | Size and alignment
--- | --- | ---
`@` | native | native
`=` | native | standard
`<` | little-endian | standard
`>` | big-endian | standard
`!` | network (= big-endian) | standard

If the first character is not one of these, "`@`" is assumed.

Native byte order is big-endian or little-endian, depending on the host system (e.g. Motorola and Sun are big-endian; Intel and DEC are little-endian).

Native size and alignment are defined as follows: `short` is 2 bytes; `int` and `long` are 4 bytes; `float` are 4 bytes and `double` are 8 bytes. Native byte order is chosen as big-endian.

Standard size and alignment are as follows: no alignment is required for any type (so you have to use pad bytes); `short` is 2 bytes; `int` and `long` are 4 bytes. `float` and `double` are 32-bit and 64-bit IEEE floating point numbers, respectively.

Note the difference between "`@`" and "`=`": both use native byte order, but the size and alignment of the latter is standardized.

The form "`!`" is available for those poor souls who claim they can't remember whether network byte order is big-endian or little-endian.

There is no way to indicate non-native byte order (i.e. force byte-swapping); use the appropriate choice of "`<`" or "`>`".

Examples (all using native byte order, size and alignment, on a big-endian machine):

       >>> from struct import *
       >>> pack('hhl', 1, 2, 3)
       '\000\001\000\002\000\000\000\003'
       >>> unpack('hhl', '\000\001\000\002\000\000\000\003')
       (1, 2, 3)
       >>> calcsize('hhl')
       8
       >>>

Hint: to align the end of a structure to the alignment requirement of a particular type, end the format with the code for that type with a repeat count of zero, e.g. the format `'llh0l'` specifies two pad bytes at the end, assuming longs are aligned on 4-byte boundaries. This only works when native size and alignment are in effect; standard size and alignment does not enforce any alignment. For the complete documentation on the struct module, please see the "Python Library Reference"

The module is based on the original structmodule.c except that all mistakes and errors are my own. Original author unknown.

Version:
  struct.java,v 1.6 1999/04/17 12:04:34 fb Exp
Author:
  Finn Bock, bckfnn@pipmail.dknet.dk

Field Summary
`static String` | `__doc__`
`static PyObject` | `error` Exception raised on various occasions; argument is a string describing what is wrong.

Constructor Summary
`struct()`

Method Summary
`static int` | `calcsize(String format)` Return the size of the struct (and hence of the string) corresponding to the given format.
`static void` | `pack_into(PyObject[] args)`
`static PyString` | `pack(PyObject[] args)` Return a string containing the values v1, v2, ... packed according to the given format.
`static PyStruct` | `Struct(PyObject[] args, String[] keywords)`
`static PyTuple` | `unpack_from(String format, String string)`
`static PyTuple` | `unpack_from(String format, String string, int offset)`
`static PyTuple` | `unpack(String format, PyArray buffer)`
`static PyTuple` | `unpack(String format, String string)` Unpack the string (presumably packed by pack(fmt, ...)) according to the given format.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### error

    public static final PyObject error

  Exception raised on various occasions; argument is a string describing what is wrong.

### __doc__

    public static String __doc__

Constructor Detail

### struct

    public struct()

Method Detail

### calcsize

    public static int calcsize(String format)

  Return the size of the struct (and hence of the string) corresponding to the given format.

### pack

    public static PyString pack(PyObject[] args)

  Return a string containing the values v1, v2, ... packed according to the given format. The arguments must match the values required by the format exactly.

### pack_into

    public static void pack_into(PyObject[] args)

### unpack

    public static PyTuple unpack(String format,
                                 String string)

  Unpack the string (presumably packed by pack(fmt, ...)) according to the given format. The result is a tuple even if it contains exactly one item. The string must contain exactly the amount of data required by the format (i.e. len(string) must equal calcsize(fmt)).

### unpack

    public static PyTuple unpack(String format,
                                 PyArray buffer)

### unpack_from

    public static PyTuple unpack_from(String format,
                                      String string)

### unpack_from

    public static PyTuple unpack_from(String format,
                                      String string,
                                      int offset)

### Struct

    public static PyStruct Struct(PyObject[] args,
                                  String[] keywords)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Jython homepage